Complexity:
Is Regression: No
Sprint Focus:
Subject: AdoDB error on editing a page
Description

In dev master using postgresql (with dbal and adodb), when clicking on Edit page properties in BE I get this error:

#1421053336: ADOdb could not run this query: SELECT "uid" FROM "sys_category" WHERE FIND_IN_SET('0', "parent") != 0
OR "parent" = ''

This error is thrown by a "if (!is_object($sqlResult))" test ($sqlResult is a huge amount of "object(ADORecordSet_postgres8)" whereas
it should be, I presume, one single object).
I can't locate where this $sqlResult comes from.

Related issues:
related to Core - Bug # 46271: DB-error with postgreSQL Resolved 2013-03-14
related to Core - Bug # 67155: Invalid SQL Query for sys_categories Resolved 2015-05-26

Associated revisions
Revision 14f04a6a - 2015-07-22 18:50 - Morton Jonuschat

[BUGFIX] dbal: Cast field to CHAR for FIND_IN_SET()

Implement explicit casting of fields to a character representation.
Most DBMS are stricter in regard to data type checking and emit an
error when trying to use FIND_IN_SET() on non-text field types.

On the DBAL side of things the DBMS specifics are used to define that
an explicit cast is required for FIND_IN_SET() so that a query including
the CAST statement gets generated.

A PostgreSQL Specific has been added to enable the explicit casting in
conjuction with DBAL. To avoid checking repeatedly if a DBMS has defined
specific requirements a NullSpecific has been implemented that gets used
as a default.

In the DatabaseTreeDataProvider the listFieldQuery() function has been
changed to use an explicit CAST instead of relying on the implicit
cast done by MySQL when comparing it to an empty string.

The SqlParser has been extended with the support for CAST.
Resolves: #67155
Resolves: #67172
Resolves: #46271
Releases: master, 6.2
Change-Id: Ic77d1700e0fb4e3723c90b34e131dafb456038e0
Reviewed-on: http://review.typo3.org/39779
Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>
Tested-by: Andreas Fernandez <typo3@scripting-base.de>
Reviewed-by: Markus Klein <markus.klein@typo3.org>
Tested-by: Markus Klein <markus.klein@typo3.org>

Revision a780e46a - 2015-07-22 20:23 - Morton Jonuschat

[BUGFIX] dbal: Cast field to CHAR for FIND_IN_SET()

Implement explicit casting of fields to a character representation.
Most DBMS are stricter in regard to data type checking and emit an
error when trying to use FIND_IN_SET() on non-text field types.

On the DBAL side of things the DBMS specifics are used to define that
an explicit cast is required for FIND_IN_SET() so that a query including
the CAST statement gets generated.

A PostgreSQL Specific has been added to enable the explicit casting in
conjuction with DBAL. To avoid checking repeatedly if a DBMS has defined
specific requirements a NullSpecific has been implemented that gets used
as a default.

In the DatabaseTreeDataProvider the listFieldQuery() function has been
changed to use an explicit CAST instead of relying on the implicit
cast done by MySQL when comparing it to an empty string.

The SqlParser has been extended with the support for CAST.

Resolves: #67155
Resolves: #67172
Resolves: #46271
Releases: master, 6.2
Change-Id: Ic77d1700e0fb4e3723c90b34e131dafb456038e0
Reviewed-on: http://review.typo3.org/39779
Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>
Tested-by: Andreas Fernandez <typo3@scripting-base.de>
Reviewed-by: Markus Klein <markus.klein@typo3.org>
Tested-by: Markus Klein <markus.klein@typo3.org>
Reviewed-on: http://review.typo3.org/41842

History
#1 - 2015-05-28 09:37 - alexis nicolas

Additional information:
Script
mod.php?M=record_edit&moduleToken=8122495a9af184a42f55f1a33fe13fd6012a2294&edit[pages][112]=edit&returnUrl=/TYPO3.CMS/typo3/mod.php?M=Dw
p?M=Dweb_layout/moduleToken=D0fb5f69ddc295f9dcc6263262f151a9c54613b9e&id=112 returns a 500 error whereas I'm on a localhost.

PostrgreSQL log returns:

function find_in_set(unknown, bigint) doesn't exist
No function matches given name and argument type
You must add explicit type cast

#2 - 2015-05-28 14:17 - alexis nicolas
- % Done changed from 0 to 100

Solution given in #46271 works here.

#3 - 2015-05-28 23:07 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#4 - 2015-05-29 08:51 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#5 - 2015-06-08 09:14 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#6 - 2015-06-08 09:19 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#7 - 2015-06-09 18:41 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#8 - 2015-06-17 23:19 - Gerrit Code Review
Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#9 - 2015-07-17 10:33 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39779

#10 - 2015-07-22 19:00 - Morton Jonuschat
- Status changed from Under Review to Resolved

Applied in changeset commit:14f04a6a526ce654c86e7e62bcf4cb09cfca6eb2.

#11 - 2015-07-22 20:06 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/41842

#12 - 2015-07-22 20:29 - Morton Jonuschat
- Status changed from Under Review to Resolved

Applied in changeset commit:a780e46ad709bcf5df9253182c620cec8c748bc4.
